<?php

if( !defined( 'TYPO3_MODE' ) )
{
	die( 'Access denied.' );
}

/* * ****************************************************************************
 * Set TYPO3 version
 * **************************************************************************** */

// #t1597, 171007, ~
list( $main, $sub, $bugfix ) = explode( '.', TYPO3_version );
$typo3Version = ( ( int ) $main ) * 1000000;
$typo3Version = $typo3Version + ( ( int ) $sub ) * 1000;
$typo3Version = $typo3Version + ( ( int ) $bugfix ) * 1;

/* * ****************************************************************************
 * INDEX
 *
 * Set TYPO3 version
 * Configuration by the extension manager
 *    Localization support
 *    Store record configuration
 * Enables the Include Static Templates
 * Add dynamic static files
 * Add pagetree icons
 * Methods for backend workflows
 * Plugin Configuration
 * Allow tables on pages
 * **************************************************************************** */



/* * ****************************************************************************
 * Set TYPO3 version
 * **************************************************************************** */

list( $main, $sub, $bugfix ) = explode( '.', TYPO3_version );
$version = ( ( int ) $main ) * 1000000;
$version = $version + ( ( int ) $sub ) * 1000;
$version = $version + ( ( int ) $bugfix ) * 1;
$typo3Version = $version;


/* * ****************************************************************************
 * Configuration by the extension manager
 * **************************************************************************** */

$confArr = unserialize( $GLOBALS[ 'TYPO3_CONF_VARS' ][ 'EXT' ][ 'extConf' ][ 'radialsearch' ] );

// Language for labels of static templates and page tsConfig
$llStatic = $confArr[ 'LLstatic' ];
switch( $llStatic )
{
	case( 'German' ):
		$llStatic = 'de';
		break;
	default:
		$llStatic = 'default';
}

/* * ****************************************************************************
 * Enables the Include Static Templates
 * **************************************************************************** */

switch( true )
{
	case($llStatic == 'de'):
		// German
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'Configuration/TypoScript/Base/', 'Radial Search [1.0] Basis' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'Configuration/TypoScript/Properties/De/', 'Radial Search [1.1] + Sprache: Deutsch' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'Configuration/TypoScript/NearestLocation/', 'Radial Search [2.0] Nächster Standort' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'static/', '[VERALTET] Radial Search [-] Basis' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'static/properties/de/', '[VERALTET] Radial Search [-] + Sprache: Deutsch' );
		break;
	default:
		// English
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'Configuration/TypoScript/Base/', 'Radial Search [1.0] Basis' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'Configuration/TypoScript/Properties/De/', 'Radial Search [1.1] + Language: German' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'Configuration/TypoScript/NearestLocation/', 'Radial Search [2.0] Nearest location' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'static/', '[DEPRECATED] Radial Search [-] Basis' );
		\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addStaticFile( $_EXTKEY, 'static/properties/de/', '[DEPRECATED] Radial Search [-] + Language: German' );
		break;
}
// Case $llStatic
// Enables the Include Static Templates


/* * ****************************************************************************
 * Add pagetree icons
 * **************************************************************************** */

$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( \TYPO3\CMS\Core\Imaging\IconRegistry::class );

$extIcon = array(
		'identifier' => 'app-radialsearch'
		, 'key' => 'radialsearch'	 // <- Key must be the part behind contain- of the identifier!
		, 'label' => 'Radial Search'
		, 'source' => 'EXT:radialsearch/ext_icon.svg'
);
$iconRegistry->registerIcon(
				$extIcon[ 'identifier' ]
				, \TYPO3\CMS\Core\Imaging\IconProvider\BitmapIconProvider::class
				, [ 'source' => $extIcon[ 'source' ] ]
);
$TCA[ 'pages' ][ 'columns' ][ 'module' ][ 'config' ][ 'items' ][] = array(
		$extIcon[ 'label' ]
		, $extIcon[ 'key' ]
		, $extIcon[ 'identifier' ]
);
$TCA[ 'pages' ][ 'ctrl' ][ 'typeicon_classes' ][ $extIcon[ 'identifier' ] ] = $extIcon[ 'identifier' ];

//switch( true )
//{
//	case( $llStatic == 'de' ):
//		// German
//		$TCA[ 'pages' ][ 'columns' ][ 'module' ][ 'config' ][ 'items' ][] = array( 'Umkreissuche', 'radsearch', \Netzmacher\Refresh\Compatibility\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg' );
//		break;
//	default:
//		// English
//		$TCA[ 'pages' ][ 'columns' ][ 'module' ][ 'config' ][ 'items' ][] = array( 'Radial Search', 'radsearch', \Netzmacher\Refresh\Compatibility\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg' );
//}
//// Case $llStatic
////  #34858, 120320, dwildt
//TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon( 'pages', 'contains-radsearch', '../typo3conf/ext/radialsearch/ext_icon.svg' );


/* * ****************************************************************************
 * Methods for backend workflows
 * **************************************************************************** */

$path2lib = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( 'radialsearch' ) . 'Classes/Utility/UserFunc/';
require_once( $path2lib . 'class.tx_radialsearch_userfunc.php' );


/* * ****************************************************************************
 * Plugin Configuration
 * **************************************************************************** */

$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $_EXTKEY . '_pi1' ] = 'layout,select_key,recursive,pages';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $_EXTKEY . '_pi1' ] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin( array(
		'LLL:EXT:radialsearch/Resources/Private/Language/locallang_db.xml:pi1',
		$_EXTKEY . '_pi1',
		\Netzmacher\Refresh\Compatibility\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
				), 'list_type' );
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue( $_EXTKEY . '_pi1', 'FILE:EXT:' . $_EXTKEY . '/Classes/Plugins/Pi1/flexform.xml' );

$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $_EXTKEY . '_pi2' ] = 'layout,select_key,recursive,pages';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $_EXTKEY . '_pi2' ] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin( array(
		'LLL:EXT:radialsearch/Resources/Private/Language/locallang_db.xml:pi2',
		$_EXTKEY . '_pi2',
		\Netzmacher\Refresh\Compatibility\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
				), 'list_type' );
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue( $_EXTKEY . '_pi2', 'FILE:EXT:' . $_EXTKEY . '/Classes/Plugins/Pi1/flexform.xml' );

$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $_EXTKEY . '_pi3' ] = 'layout,select_key,recursive,pages';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $_EXTKEY . '_pi3' ] = 'pi_flexform';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin( array(
		'LLL:EXT:radialsearch/Resources/Private/Language/locallang_db.xml:pi3',
		$_EXTKEY . '_pi3',
		\Netzmacher\Refresh\Compatibility\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
				), 'list_type' );
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue( $_EXTKEY . '_pi3', 'FILE:EXT:' . $_EXTKEY . '/Classes/Plugins/Pi1/flexform.xml' );


/* * ****************************************************************************
 * Allow tables on pages
 * **************************************************************************** */

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::allowTableOnStandardPages( 'tx_radialsearch_postalcodes' );
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToInsertRecords( 'tx_radialsearch_postalcodes' );