plugin.tx_radialsearch {
    // htmlClass, linearDistance
  masterTemplates =
  masterTemplates {
      // [STRING] HTML class depending on radius. Returns: radialsearch radialsearch-without-search, radialsearch radialsearch-within-radius, radialsearch radialsearch-outside-radius
    htmlClass = COA
    htmlClass {
        // HTML class without any radial search. Returns: radialsearch radialsearch-without-search
      10 = TEXT
      10 {
        if {
          isFalse {
            data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
          }
        }
        value       = radialsearch radialsearch-without-search
        noTrimWrap  = | ||
      }
        // HTML class with a radial search
      20 = COA
      20 {
        if {
          isTrue {
            data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.select}
          }
        }
          // HTML class, if record is within the given radius
        10 = TEXT
        10 {
          if {
            isLessThan {
              field = {$plugin.tx_radialsearch_pi1.distance.fieldLabel}
            }
            value {
              // #i0014, 150430, dwildt, 1-/+
              //data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.select}
              stdWrap {
                data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.select}
                htmlSpecialChars = 1
                stripHtml = 1
                //rawUrlEncode = 1
              }
            }
          }
          value = radialsearch radialsearch-within-radius
          noTrimWrap  = | ||
        }
          // HTML class, if record is outside of the given radius
        20 = TEXT
        20 {
          if {
            isLessThan {
              field = {$plugin.tx_radialsearch_pi1.distance.fieldLabel}
            }
            value {
              // #i0014, 150430, dwildt, 1-/+
              //data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.select}
              stdWrap {
                data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.select}
                htmlSpecialChars = 1
                stripHtml = 1
                //rawUrlEncode = 1
              }
            }
            negate = 1
          }
          value = radialsearch radialsearch-outside-radius
          noTrimWrap  = | ||
        }
      }
    }
      // [DOUBLE] Linear distance
    linearDistanceDouble = TEXT
    linearDistanceDouble {
        // if is true GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
      if =
      if {
        isTrue {
          data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
        }
      }
      required    = 1
      field       = {$plugin.tx_radialsearch_pi1.distance.fieldLabel}
      numberFormat {
        decimals      = {$plugin.tx_radialsearch_pi1.distance.decimals}
        dec_point     = {$plugin.tx_radialsearch_pi1.distance.dec_point}
        thousands_sep = {$plugin.tx_radialsearch_pi1.distance.thousands_sep}
      }
    }
      // [STRING] Linear distance
    linearDistanceString = COA
    linearDistanceString {
        // if is true GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
      if =
      if {
        isTrue {
          data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
        }
      }
      wrap = {$plugin.tx_radialsearch_pi1.distance.wrap}
        // [DOUBLE] Linear distance
      10 = TEXT
      10 {
        field = {$plugin.tx_radialsearch_pi1.distance.fieldLabel}
        numberFormat {
          decimals      = {$plugin.tx_radialsearch_pi1.distance.decimals}
          dec_point     = {$plugin.tx_radialsearch_pi1.distance.dec_point}
          thousands_sep = {$plugin.tx_radialsearch_pi1.distance.thousands_sep}
        }
      }
        // label
      20 = TEXT
      20 {
        data = LLL:EXT:radialsearch/Resources/Private/Language/locallang_db.xml:label.distancefrom_long
        noTrimWrap = | | |
      }
        // GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
      30 = TEXT
      30 {
        // #i0014, 150430, dwildt, 1-/+
        //data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
        stdWrap {
          data = GP:{$plugin.tx_radialsearch_pi1.gp.parameter}|{$plugin.tx_radialsearch_pi1.gp.input}
          htmlSpecialChars = 1
          stripHtml = 1
          //rawUrlEncode = 1
        }
      }
    }
  }
}